#include "lcd.h"
#include "stdlib.h"
#include "font.h" 
#include "usart.h"
#include "delay.h"	 
   
					 
//ɫ,ɫ
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF;  
	 

//LCDҪ
//ĬΪ
_lcd_dev lcddev;

#if LCD_FAST_IO==1 //IO
//дĴ
void LCD_WR_REG(u16 data)
{ 
	LCD_RS_CLR;//дַ  
 	LCD_CS_CLR; 
	DATAOUT(data); 
	LCD_WR_CLR; 
	LCD_WR_SET; 
 	LCD_CS_SET;   
}
#else//IO
//дĴ
void LCD_WR_REG(u16 data)
{ 
	LCD_RS=0;//дַ  
 	LCD_CS=0; 
	DATAOUT(data); 
	LCD_WR=0; 
	LCD_WR=1; 
 	LCD_CS=1;   
} 	
#endif	

//дĴ
void LCD_WriteReg(u16 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}	   
//Ĵ
u16 LCD_ReadReg(u8 LCD_Reg)
{										   
	u16 t;
	LCD_WR_REG(LCD_Reg);  //дҪļĴ  
	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0XFFFF;    //ȫ
#if LCD_FAST_IO==1 //IO
	LCD_RS_SET;
	LCD_CS_CLR;
	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD_CLR;
	delay_us(5);//FOR 8989,ʱ5us					   
	LCD_RD_SET;
	t=DATAIN;  
	LCD_CS_SET; 
#else
	LCD_RS=1;
	LCD_CS=0;
	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD=0;					   
	LCD_RD=1;
	t=DATAIN;  
	LCD_CS=1; 
#endif  
	GPIOB->CRL=0X33333333; //PB0-7  
	GPIOB->CRH=0X33333333; //PB8-15 
	GPIOB->ODR=0XFFFF;    //ȫ
	return t;  
}   
//ʼдGRAM
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(0x2c);
}	 
//LCDдGRAM
void LCD_WriteRAM(u16 RGB_Code)
{							    
	LCD_WR_DATA(RGB_Code);//дʮλGRAM
}	 


//ùλ
//Xpos:
//Ypos:
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{	 	    
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(Xpos>>8); 
		LCD_WR_DATA(Xpos&0XFF);	
		LCD_WR_DATA((lcddev.width-1)>>8);
		LCD_WR_DATA((lcddev.width-1)&0XFF);
		
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(Ypos>>8); 
		LCD_WR_DATA(Ypos&0XFF);
		LCD_WR_DATA((lcddev.height-1)>>8);
		LCD_WR_DATA((lcddev.height-1)&0XFF);
}  

//LCDԶɨ跽
//ע:ܻܵ˺õӰ
//,һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
//dir:0~7,8(嶨lcd.h)  	   
void LCD_Scan_Dir(u8 dir)
{
	u16 regval=0;
	u8 dirreg=0;
	u16 temp;  
	
	switch(dir)
	{
			case L2R_U2D://,ϵ
				regval|=(0<<7)|(0<<6)|(0<<5); 
				break;
			case L2R_D2U://,µ
				regval|=(1<<7)|(0<<6)|(0<<5); 
				break;
			case R2L_U2D://ҵ,ϵ
				regval|=(0<<7)|(1<<6)|(0<<5); 
				break;
			case R2L_D2U://ҵ,µ
				regval|=(1<<7)|(1<<6)|(0<<5); 
				break;	 
			case U2D_L2R://ϵ,
				regval|=(0<<7)|(0<<6)|(1<<5); 
				break;
			case U2D_R2L://ϵ,ҵ
				regval|=(0<<7)|(1<<6)|(1<<5); 
				break;
			case D2U_L2R://µ,
				regval|=(1<<7)|(0<<6)|(1<<5); 
				break;
			case D2U_R2L://µ,ҵ
				regval|=(1<<7)|(1<<6)|(1<<5); 
				break;	 
	}
	dirreg=0X36;
 	regval|=0X08;//BGR   
   
	LCD_WriteReg(dirreg,regval);
 	if((regval&0X20)||lcddev.dir==1)
	{
		if(lcddev.width<lcddev.height)//X,Y
		{
		  temp=lcddev.width;
			lcddev.width=lcddev.height;
			lcddev.height=temp;
 		}
		}else  
		{
			if(lcddev.width>lcddev.height)//X,Y
			{
				temp=lcddev.width;
				lcddev.width=lcddev.height;
				lcddev.height=temp;
 			}
		}  
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(0);LCD_WR_DATA(0);
		LCD_WR_DATA((lcddev.width-1)>>8);LCD_WR_DATA((lcddev.width-1)&0XFF);
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(0);LCD_WR_DATA(0);
		LCD_WR_DATA((lcddev.height-1)>>8);LCD_WR_DATA((lcddev.height-1)&0XFF); 	
}

//LCDʾ6804ֺ֧ʾ
//dir:0,1,
void LCD_Display_Dir(u8 dir)
{
	if(dir==0)//
	{
		lcddev.dir=0;//
		lcddev.wramcmd=0X2C;
	 	lcddev.setxcmd=0X2A;
		lcddev.setycmd=0X2B;  	 
		lcddev.width=320;
		lcddev.height=480;			
	}else 				//
	{	  				
		lcddev.dir=1;	//
		lcddev.wramcmd=0X2C;
	 	lcddev.setxcmd=0X2A;
		lcddev.setycmd=0X2B;  
		lcddev.width=480;
		lcddev.height=320; 
	}
	//LCD_Scan_Dir(DFT_SCAN_DIR);	//Ĭɨ跽
}	

//
//x:0~239
//y:0~319
//POINT_COLOR:˵ɫ
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);//ùλ 
	LCD_WR_REG(0X2C);//ʼдGRAM
	LCD_WR_DATA(POINT_COLOR); 
} 	 
//ʼlcd
//óʼԳʼILI93XXҺ,ǻILI9320!!!
//ͺŵоƬûв! 
void LCD_Init(void)
{  
     										 
	GPIO_InitTypeDef GPIO_InitStructure;

 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOB|RCC_APB2Periph_AFIO, ENABLE); 
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10|GPIO_Pin_9|GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6;	   //GPIO_Pin_10
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); //GPIOC	
	GPIO_SetBits(GPIOC,GPIO_Pin_10|GPIO_Pin_9|GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6);


	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;	//  
	GPIO_Init(GPIOB, &GPIO_InitStructure); //GPIOB 
	GPIO_SetBits(GPIOB,GPIO_Pin_All);

//R61529
LCD_WR_REG(0x11);
delay_ms(200);
LCD_WR_REG(0xB0);
LCD_WR_DATA(0x04);
LCD_WR_REG(0xB3);
LCD_WR_DATA(0x02);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_REG(0xB4);
LCD_WR_DATA(0x00);
LCD_WR_REG(0xC0);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0xDF);
LCD_WR_DATA(0x40);
LCD_WR_DATA(0x10);//13
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x55);//54
LCD_WR_REG(0xC1);//Frequency
LCD_WR_DATA(0x07);
LCD_WR_DATA(0x27);
LCD_WR_DATA(0x08);
LCD_WR_DATA(0x08);
LCD_WR_DATA(0x00);
LCD_WR_REG(0xC4);//Panel Driver
LCD_WR_DATA(0x57);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x05);
LCD_WR_DATA(0x03);
//--Vsync, Hsync, DE, CLK Polarity Setting--//
LCD_WR_REG(0xC6);
LCD_WR_DATA(0x04);//rising edge
//Gamma setting start
LCD_WR_REG(0xC8);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
LCD_WR_REG(0xC9);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
LCD_WR_REG(0xCA);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
LCD_WR_DATA(0x03);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x1A);
LCD_WR_DATA(0x24);
LCD_WR_DATA(0x32);
LCD_WR_DATA(0x4B);
LCD_WR_DATA(0x3B);
LCD_WR_DATA(0x29);
LCD_WR_DATA(0x1F);
LCD_WR_DATA(0x18);
LCD_WR_DATA(0x12);
LCD_WR_DATA(0x04);
//Gamma setting end
LCD_WR_REG(0xD0);
LCD_WR_DATA(0x99);//DC4~1//A5
LCD_WR_DATA(0x06);//BT
LCD_WR_DATA(0x08);
LCD_WR_DATA(0x20);
LCD_WR_DATA(0x29);//VC1, VC2
LCD_WR_DATA(0x04);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x08);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x06);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x20);
LCD_WR_REG(0xD1);//VCOM
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x20);//45 38 VPLVL
LCD_WR_DATA(0x20);//45 38 VNLVL
LCD_WR_DATA(0x15);//32 2A VCOMDC
LCD_WR_REG(0xE0);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_REG(0xE1);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_REG(0xE2);
LCD_WR_DATA(0x00);
LCD_WR_REG(0x36);
LCD_WR_DATA(0x00);
LCD_WR_REG(0x3A);
LCD_WR_DATA(0x55);// 16-Bit 55h, 18-Bit 66h,24-bit 77h
LCD_WR_REG(0x2A);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0x3F);//320
LCD_WR_REG(0x2B);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x00);
LCD_WR_DATA(0x01);
LCD_WR_DATA(0xDF);//480
LCD_WR_REG(0x29);
delay_ms(20);
LCD_WR_REG(0x2C);
	
		LCD_Display_Dir(0);	
		LCD_LED=1;//	 
		LCD_Clear(WHITE);
}  		  
  
//
//color:Ҫɫ
void LCD_Clear(u16 color)
{
	u32 index=0;      
	u32 totalpoint=lcddev.width;
	totalpoint*=lcddev.height; 	//õܵ
	
	LCD_SetCursor(0x00,0x0000);	//ùλ 
	LCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<totalpoint;index++)
	{
		LCD_WR_DATA(color);	   
	}
}  

//
//x1,y1:
//x2,y2:յ  
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}    
//
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
{
	LCD_DrawLine(x1,y1,x2,y1);
	LCD_DrawLine(x1,y1,x1,y2);
	LCD_DrawLine(x1,y2,x2,y2);
	LCD_DrawLine(x2,y1,x2,y2);
}
//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
void Draw_Circle(u16 x0,u16 y0,u8 r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a);             //3           
		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0-a,y0+b);             //1       
		LCD_DrawPoint(x0-b,y0-a);             //7           
		LCD_DrawPoint(x0-a,y0-b);             //2             
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0-b);             //5
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a,y0+b);
	}
} 
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  
#if USE_HORIZONTAL==1
#define MAX_CHAR_POSX 392
#define MAX_CHAR_POSY 232 
#else     
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 392
#endif 
    u8 temp;
    u8 pos,t;
	u16 x0=x;
	u16 colortemp=POINT_COLOR;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;	    
	//ô		   
	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD_DrawPoint(x,y);	
				temp>>=1; 
				x++;
		    }
			x=x0;
			y++;
		}	
	}else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)LCD_DrawPoint(x+t,y+pos);//һ     
		        temp>>=1; 
		    }
		}
	}
	POINT_COLOR=colortemp;	    	   	 	  
}   
//m^n
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ
//num:ֵ(0~4294967295);	 
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
} 
//ʾ2
//x,y:
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~99);	 
void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode)
{         	
	u8 t,temp;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode); 
	}
} 
//ʾַ
//x,y:  
//*p:ַʼַ
//16
void LCD_ShowString(u16 x,u16 y,const u8 *p)
{         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}
        LCD_ShowChar(x,y,*p,16,0);
        x+=8;
        p++;
    }  
}

